//
//  IFXPDFColorSpace.h
//  IFXPDFFactory
//
//  Created by Sorin Nistor on 4/29/12.
//  Copyright (c) 2012 iPDFdev.com. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef enum {
    /// <summary>
    /// Unknown colorspace.
    /// </summary>
    IFXPDFColorSpaceUnknown = 0,
    /// <summary>
    /// RGB colorspace.
    /// </summary>
    IFXPDFColorSpaceRgb = 1,
    /// <summary>
    /// CMYK colorspace.
    /// </summary>
    IFXPDFColorSpaceCmyk = 2,
    /// <summary>
    /// Gray colorspace.
    /// </summary>
    IFXPDFColorSpaceGray = 3,
    /// <summary>
    /// Calibrated gray colorspace.
    /// </summary>
    IFXPDFColorSpaceCalGray = 4,
    /// <summary>
    /// Calibrated RGB colorspace.
    /// </summary>
    IFXPDFColorSpaceCalRgb = 5,
    /// <summary>
    /// Lab colorspace.
    /// </summary>
    IFXPDFColorSpaceLab = 6,
    /// <summary>
    /// ICC colorspace.
    /// </summary>
    IFXPDFColorSpaceIccBased = 7,
    /// <summary>
    /// Indexed colorspace.
    /// </summary>
    IFXPDFColorSpaceIndexed = 8,
    /// <summary>
    /// Separation colorspace.
    /// </summary>
    IFXPDFColorSpaceSeparation = 9,
    /// <summary>
    /// DeviceN colorspace.
    /// </summary>
    IFXPDFColorSpaceDeviceN = 10,
    /// <summary>
    /// Pattern colorspace.
    /// </summary>
    IFXPDFColorSpacePattern = 11
} IFXPDFColorSpaceType;

@class IFXPDFObject;

@interface IFXPDFColorSpace : NSObject {
    IFXPDFColorSpaceType _type;
    IFXPDFObject* _cosColorSpace;
    int _numberOfColorComponents;
}

@property (nonatomic, readonly) IFXPDFColorSpaceType type;

- (id) init;
- (void) dealloc;

- (int) numberOfColorComponents;

@end
