//
//  IFXPDFDocument.h
//  IFXPDFFactory
//
//  Created by Sorin Nistor on 4/10/12.
//  Copyright (c) 2012 iPDFdev.com. All rights reserved.
//

#import <Foundation/Foundation.h>

@class IFXPDFFile;
@class IFXPDFPageCollection;
@class IFXPDFOptionalContentProperties;
@class IFXPDFDocumentInformation;
@class IFXPDFViewerPreferences;

@interface IFXPDFDocument : NSObject {
    IFXPDFFile* _pdfFile;
    IFXPDFPageCollection* _pages;
}

@property (nonatomic, readonly) IFXPDFPageCollection* pages;
@property (nonatomic, strong) IFXPDFOptionalContentProperties* optionalContentProperties;
@property (nonatomic, strong) IFXPDFDocumentInformation* documentInformation;
@property (nonatomic, strong) IFXPDFViewerPreferences* viewerPreferences;

- (id) init;
- (void) dealloc;

- (BOOL) writeToFile: (NSString*) path;

@end
