//
//  IFXPDFMatrix.h
//  IFXPDFFactory
//
//  Created by Sorin Nistor on 5/2/12.
//  Copyright (c) 2012 iPDFdev.com. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface IFXPDFMatrix : NSObject

@property (nonatomic, assign) double m11;
@property (nonatomic, assign) double m12;
@property (nonatomic, assign) double m21;
@property (nonatomic, assign) double m22;
@property (nonatomic, assign) double tx;
@property (nonatomic, assign) double ty;

- (id) init;
- (id) initWithM11: (double) m11 m12: (double) m12 m21: (double) m21 m22: (double) m22
                tx: (double) tx ty: (double) ty;
- (id) initWithMatrix: (IFXPDFMatrix*) matrix;

+ (IFXPDFMatrix*) matrixWithM11: (double) m11 m12: (double) m12 m21: (double) m21 m22: (double) m22
                             tx: (double) tx ty: (double) ty;

- (void) multiply: (IFXPDFMatrix*) matrix;
- (void) translateWithTx: (double) tx andTy: (double) ty;
- (void) rotateWithAngle: (double) angle;
- (void) scaleWithSx: (double) sx andSy: (double) sy;

@end
