//
//  IFXPDFPage.h
//  IFXPDFFactory
//
//  Created by Sorin Nistor on 4/26/12.
//  Copyright (c) 2012 iPDFdev.com. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "IFXPDFContentStreamContainer.h"

@class IFXPDFStandardRectangle;
@class IFXPDFGraphics;
@class IFXPDFPageGraphics;
@class IFXPDFDocument;

@interface IFXPDFPage : IFXPDFContentStreamContainer

@property (nonatomic, readonly) IFXPDFPageGraphics* graphics;
@property (nonatomic, weak) IFXPDFDocument* document;
@property (nonatomic, strong) IFXPDFStandardRectangle* mediaBox;
@property (nonatomic, strong) IFXPDFStandardRectangle* cropBox;
@property (nonatomic, strong) IFXPDFStandardRectangle* artBox;
@property (nonatomic, strong) IFXPDFStandardRectangle* trimBox;
@property (nonatomic, strong) IFXPDFStandardRectangle* bleedBox;
@property (nonatomic) double width;
@property (nonatomic) double height;
@property (nonatomic) int rotation;

- (id) init;
- (void) dealloc;

+ (IFXPDFPage*) emptyPage;

@end
