//
//  IFXPDFPageCollection.h
//  IFXPDFFactory
//
//  Created by Sorin Nistor on 4/26/12.
//  Copyright (c) 2012 iPDFdev.com. All rights reserved.
//

#import <Foundation/Foundation.h>

@class IFXPDFStandaloneDictionary;
@class IFXPDFDocument;
@class IFXPDFPage;

@interface IFXPDFPageCollection : NSObject {
    IFXPDFDocument* _document;
    IFXPDFStandaloneDictionary* _cosPages;
}

- (id) init;
- (void) dealloc;

- (NSUInteger) count;
- (void) addPage: (IFXPDFPage*) page;
- (void) insertPage: (IFXPDFPage*) page atIndex: (unsigned long) index;
- (IFXPDFPage*) pageAtIndex: (NSUInteger) index;
- (NSUInteger) indexOfPage: (IFXPDFPage*) page;
- (void) removePageAtIndex: (NSUInteger) index;
- (void) removePage: (IFXPDFPage*) page;
- (void) removeAllPages;

@end
