//
//  IFXPDFPath.h
//  IFXPDFFactory
//
//  Created by Sorin Nistor on 5/7/12.
//  Copyright (c) 2012 iPDFdev.com. All rights reserved.
//

#import <Foundation/Foundation.h>

@class IFXPDFBlockStream;

@interface IFXPDFPath : NSObject {
    IFXPDFBlockStream* _stream;
}

- (id) init;
- (void) dealloc;

+ (IFXPDFPath*) emptyPath;

- (void) moveToX: (double) x y: (double) y;
- (void) lineToX: (double) x y: (double) y;
- (void) polyLineTo: (NSArray*) points;
- (void) polygon: (NSArray*) points;
- (void) rectangleAtX: (double) x 
                    y: (double) y 
            withWidth: (double) width 
               height: (double) height 
             rotation: (double) rotation;
- (void) roundRectangleAtX: (double) x 
                         y: (double) y 
                 withWidth: (double) width 
                    height: (double) height 
              ellipseWidth: (double) ellipseWidth 
             ellipseHeight: (double) ellipseHeight 
                  rotation: (double) rotation;
- (void) bezierToX1: (double) x1 
                 y1: (double) y1 
                 x2: (double) x2 
                 y2: (double) y2 
                 x3: (double) x3 
                 y3: (double) y3;
- (void) polyBezierTo: (NSArray*) points;
- (void) ellipseAtX: (double) x 
                  y: (double) y 
          withWidth: (double) width 
             height: (double) height 
           rotation: (double) rotation;
- (void) closeSubpath;

@end
