//
//  IFXPDFRgbColor.h
//  IFXPDFFactory
//
//  Created by Sorin Nistor on 4/29/12.
//  Copyright (c) 2012 iPDFdev.com. All rights reserved.
//

#import "IFXPDFColor.h"
#import "IFXPDFRgbColorSpace.h"

@interface IFXPDFRgbColor : IFXPDFColor 

@property (nonatomic) double red;
@property (nonatomic) double green;
@property (nonatomic) double blue;

- (id) init;
- (id) initWithRed: (double) red green: (double) green blue: (double) blue;
- (void) dealloc;
- (BOOL) isEqual:(id)object;

+ (IFXPDFRgbColor*) rgbColorWithRed: (double) red green: (double) green blue: (double) blue;

+ (IFXPDFRgbColor*) aliceBlueColor;
+ (IFXPDFRgbColor*) antiqueWhiteColor;
+ (IFXPDFRgbColor*) aquaColor;
+ (IFXPDFRgbColor*) aquamarineColor;
+ (IFXPDFRgbColor*) azureColor;
+ (IFXPDFRgbColor*) beigeColor;
+ (IFXPDFRgbColor*) bisqueColor;
+ (IFXPDFRgbColor*) blackColor;
+ (IFXPDFRgbColor*) blanchedAlmondColor;
+ (IFXPDFRgbColor*) blueColor;
+ (IFXPDFRgbColor*) blueVioletColor;
+ (IFXPDFRgbColor*) brownColor;
+ (IFXPDFRgbColor*) burlyWoodColor;
+ (IFXPDFRgbColor*) cadetBlueColor;
+ (IFXPDFRgbColor*) chartreuseColor;
+ (IFXPDFRgbColor*) chocolateColor;
+ (IFXPDFRgbColor*) coralColor;
+ (IFXPDFRgbColor*) cornflowerBlueColor;
+ (IFXPDFRgbColor*) cornsilkColor;
+ (IFXPDFRgbColor*) crimsonColor;
+ (IFXPDFRgbColor*) cyanColor;
+ (IFXPDFRgbColor*) darkBlueColor;
+ (IFXPDFRgbColor*) darkCyanColor;
+ (IFXPDFRgbColor*) darkGoldenrodColor;
+ (IFXPDFRgbColor*) darkGrayColor;
+ (IFXPDFRgbColor*) darkGreenColor;
+ (IFXPDFRgbColor*) darkKhakiColor;
+ (IFXPDFRgbColor*) darkMagentaColor;
+ (IFXPDFRgbColor*) darkOliveGreenColor;
+ (IFXPDFRgbColor*) darkOrangeColor;
+ (IFXPDFRgbColor*) darkOrchidColor;
+ (IFXPDFRgbColor*) darkRedColor;
+ (IFXPDFRgbColor*) darkSalmonColor;
+ (IFXPDFRgbColor*) darkSeaGreenColor;
+ (IFXPDFRgbColor*) darkSlateBlueColor;
+ (IFXPDFRgbColor*) darkSlateGrayColor;
+ (IFXPDFRgbColor*) darkTurquoiseColor;
+ (IFXPDFRgbColor*) darkVioletColor;
+ (IFXPDFRgbColor*) deepPinkColor;
+ (IFXPDFRgbColor*) deepSkyBlueColor;
+ (IFXPDFRgbColor*) dimGrayColor;
+ (IFXPDFRgbColor*) dodgerBlueColor;
+ (IFXPDFRgbColor*) firebrickColor;
+ (IFXPDFRgbColor*) floralWhiteColor;
+ (IFXPDFRgbColor*) forestGreenColor;
+ (IFXPDFRgbColor*) fuchsiaColor;
+ (IFXPDFRgbColor*) gainsboroColor;
+ (IFXPDFRgbColor*) ghostWhiteColor;
+ (IFXPDFRgbColor*) goldColor;
+ (IFXPDFRgbColor*) goldenrodColor;
+ (IFXPDFRgbColor*) grayColor;
+ (IFXPDFRgbColor*) greenColor;
+ (IFXPDFRgbColor*) greenYellowColor;
+ (IFXPDFRgbColor*) honeydewColor;
+ (IFXPDFRgbColor*) hotPinkColor;
+ (IFXPDFRgbColor*) indianRedColor;
+ (IFXPDFRgbColor*) indigoColor;
+ (IFXPDFRgbColor*) ivoryColor;
+ (IFXPDFRgbColor*) khakiColor;
+ (IFXPDFRgbColor*) lavenderColor;
+ (IFXPDFRgbColor*) lavenderBlushColor;
+ (IFXPDFRgbColor*) lawnGreenColor;
+ (IFXPDFRgbColor*) lemonChiffonColor;
+ (IFXPDFRgbColor*) lightBlueColor;
+ (IFXPDFRgbColor*) lightCoralColor;
+ (IFXPDFRgbColor*) lightCyanColor;
+ (IFXPDFRgbColor*) lightGoldenrodYellowColor;
+ (IFXPDFRgbColor*) lightGreenColor;
+ (IFXPDFRgbColor*) lightGrayColor;
+ (IFXPDFRgbColor*) lightPinkColor;
+ (IFXPDFRgbColor*) lightSalmonColor;
+ (IFXPDFRgbColor*) lightSeaGreenColor;
+ (IFXPDFRgbColor*) lightSkyBlueColor;
+ (IFXPDFRgbColor*) lightSlateGrayColor;
+ (IFXPDFRgbColor*) lightSteelBlueColor;
+ (IFXPDFRgbColor*) lightYellowColor;
+ (IFXPDFRgbColor*) limeColor;
+ (IFXPDFRgbColor*) limeGreenColor;
+ (IFXPDFRgbColor*) linenColor;
+ (IFXPDFRgbColor*) magentaColor;
+ (IFXPDFRgbColor*) maroonColor;
+ (IFXPDFRgbColor*) mediumAquamarineColor;
+ (IFXPDFRgbColor*) mediumBlueColor;
+ (IFXPDFRgbColor*) mediumOrchidColor;
+ (IFXPDFRgbColor*) mediumPurpleColor;
+ (IFXPDFRgbColor*) mediumSeaGreenColor;
+ (IFXPDFRgbColor*) mediumSlateBlueColor;
+ (IFXPDFRgbColor*) mediumSpringGreenColor;
+ (IFXPDFRgbColor*) mediumTurquoiseColor;
+ (IFXPDFRgbColor*) mediumVioletRedColor;
+ (IFXPDFRgbColor*) midnightBlueColor;
+ (IFXPDFRgbColor*) mintCreamColor;
+ (IFXPDFRgbColor*) mistyRoseColor;
+ (IFXPDFRgbColor*) moccasinColor;
+ (IFXPDFRgbColor*) navajoWhiteColor;
+ (IFXPDFRgbColor*) navyColor;
+ (IFXPDFRgbColor*) oldLaceColor;
+ (IFXPDFRgbColor*) oliveColor;
+ (IFXPDFRgbColor*) oliveDrabColor;
+ (IFXPDFRgbColor*) orangeColor;
+ (IFXPDFRgbColor*) orangeRedColor;
+ (IFXPDFRgbColor*) orchidColor;
+ (IFXPDFRgbColor*) paleGoldenrodColor;
+ (IFXPDFRgbColor*) paleGreenColor;
+ (IFXPDFRgbColor*) paleTurquoiseColor;
+ (IFXPDFRgbColor*) paleVioletRedColor;
+ (IFXPDFRgbColor*) papayaWhipColor;
+ (IFXPDFRgbColor*) peachPuffColor;
+ (IFXPDFRgbColor*) peruColor;
+ (IFXPDFRgbColor*) pinkColor;
+ (IFXPDFRgbColor*) plumColor;
+ (IFXPDFRgbColor*) powderBlueColor;
+ (IFXPDFRgbColor*) purpleColor;
+ (IFXPDFRgbColor*) redColor;
+ (IFXPDFRgbColor*) rosyBrownColor;
+ (IFXPDFRgbColor*) royalBlueColor;
+ (IFXPDFRgbColor*) saddleBrownColor;
+ (IFXPDFRgbColor*) salmonColor;
+ (IFXPDFRgbColor*) sandyBrownColor;
+ (IFXPDFRgbColor*) seaGreenColor;
+ (IFXPDFRgbColor*) seaShellColor;
+ (IFXPDFRgbColor*) siennaColor;
+ (IFXPDFRgbColor*) silverColor;
+ (IFXPDFRgbColor*) skyBlueColor;
+ (IFXPDFRgbColor*) slateBlueColor;
+ (IFXPDFRgbColor*) slateGrayColor;
+ (IFXPDFRgbColor*) snowColor;
+ (IFXPDFRgbColor*) springGreenColor;
+ (IFXPDFRgbColor*) steelBlueColor;
+ (IFXPDFRgbColor*) tanColor;
+ (IFXPDFRgbColor*) tealColor;
+ (IFXPDFRgbColor*) thistleColor;
+ (IFXPDFRgbColor*) tomatoColor;
+ (IFXPDFRgbColor*) turquoiseColor;
+ (IFXPDFRgbColor*) violetColor;
+ (IFXPDFRgbColor*) wheatColor;
+ (IFXPDFRgbColor*) whiteColor;
+ (IFXPDFRgbColor*) whiteSmokeColor;
+ (IFXPDFRgbColor*) yellowColor;
+ (IFXPDFRgbColor*) yellowGreenColor;

@end
