//
//  IFXPDFSampleFunction.h
//  IFXPDFFactory
//
//  Created by Sorin Nistor on 8/26/12.
//  Copyright (c) 2012 iPDFdev.com. All rights reserved.
//

#import "IFXPDFFunction.h"

typedef enum {
    IFXPDFSampleFunctionLinearInterpolation = 1,
    IFXPDFSampleFunctionCubicSplineInterpolation = 3
} IFXPDFSampleFunctionInterpolationMode;

@interface IFXPDFSampledFunction : IFXPDFFunction

- (id) init;

- (NSData*) samples;
- (void) setSamples:(NSData*)samples;

- (IFXPDFNumberArray*) size;
- (void) setSize:(IFXPDFNumberArray*)size;

- (IFXPDFNumberArray*) encode;
- (void) setEncode:(IFXPDFNumberArray*)encode;

- (IFXPDFNumberArray*) decode;
- (void) setDecode:(IFXPDFNumberArray*)decode;

- (int) bitsPerSample;
- (void) setBitsPerSample:(int)bitsPerSample;

- (IFXPDFSampleFunctionInterpolationMode) interpolationMode;
- (void) setInterpolationMode:(IFXPDFSampleFunctionInterpolationMode)interpolationMode;

@end
