//
//  IFXFMasterViewController.m
//  IFXPDFFactory-iOS-SamplesBrowser
//
//  Created by Sorin Nistor on 8/29/13.
//  Copyright (c) 2013 IFXFactory. All rights reserved.
//

#import "IFXFMasterViewController.h"

#import "IFXFDetailViewController.h"

@interface IFXFMasterViewController () {
    NSMutableArray *_samples;
}
@end

@implementation IFXFMasterViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = @"IFXPDFFactory Samples";
        if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPad) {
            self.clearsSelectionOnViewWillAppear = NO;
            self.contentSizeForViewInPopover = CGSizeMake(320.0, 600.0);
        }
    }
    return self;
}
							
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    NSString* samplesPListPath = [[NSBundle mainBundle] pathForResource:@"samples" ofType:@"plist"];
    _samples = [NSMutableArray arrayWithContentsOfFile:samplesPListPath];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table View

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return _samples.count / 3;
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
        if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
            cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        }
    }

    cell.textLabel.text = _samples[indexPath.row * 3];
    return cell;
}

- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return NO;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
	    if (!self.detailViewController) {
	        self.detailViewController = [[IFXFDetailViewController alloc] initWithNibName:@"IFXFDetailViewController_iPhone"
                                                                                   bundle:nil];
	    }
	    [self.detailViewController setSampleName:_samples[indexPath.row * 3]
                                     description:_samples[indexPath.row * 3 + 1]
                                            file:_samples[indexPath.row * 3 + 2]];
        [self.navigationController pushViewController:self.detailViewController animated:YES];
    } else {
	    [self.detailViewController setSampleName:_samples[indexPath.row * 3]
                                     description:_samples[indexPath.row * 3 + 1]
                                            file:_samples[indexPath.row * 3 + 2]];
    }
}

@end
