//
//  IFXPDFDocInfoAndViewerPrefs.m
//  IFXPDFFactory-iOS-SamplesBrowser
//
//  Created by Sorin Nistor on 2/24/15.
//  Copyright (c) 2015 IFXFactory. All rights reserved.
//

#import "IFXPDFDocInfoAndViewerPrefsSample.h"

@implementation IFXPDFDocInfoAndViewerPrefsSample

+ (IFXPDFDocument*) run
{
    IFXPDFDocument* pdfDocument = [[IFXPDFDocument alloc] init];
    IFXPDFDocumentInformation* docInfo = [[IFXPDFDocumentInformation alloc] init];
    docInfo.author = @"Sorin Nistor";
    docInfo.creator = @"iPDFdev.com";
    docInfo.producer = @"IFXPDFFactory for iOS";
    docInfo.subject = @"Test for Document Information and Viewer Preferences";
    docInfo.keywords = @"pdf, document information, viewer preferences";
    docInfo.title = @"IFXPDFFactory - Document Information and Viewer Preferences";
    pdfDocument.documentInformation = docInfo;

    IFXPDFViewerPreferences* viewerPreferences = [[IFXPDFViewerPreferences alloc] init];
    viewerPreferences.hideMenubar = TRUE;
    viewerPreferences.hideToolbar = TRUE;
    viewerPreferences.hideWindowUI = TRUE;
    viewerPreferences.displayDocumentTitle = TRUE;
    viewerPreferences.fitWindow = TRUE;
    viewerPreferences.centerWindow = TRUE;
    viewerPreferences.nonFullScreenPageMode = IFXPDFDisplayModeUseOutlines;
    viewerPreferences.printScaling = IFXPDFPrintScalingModeAppDefault;
    viewerPreferences.duplexPrinting = IFXPDFDuplexPrintingModeSimplex;
    double printPageRange[2] = { 1, 10 };
    viewerPreferences.printPageRange = [IFXPDFNumberArray arrayWithNumbers:printPageRange length:2];
    viewerPreferences.numberOfCopies = 3;
    pdfDocument.viewerPreferences = viewerPreferences;

    IFXPDFBrush* blackBrush = [IFXPDFBrush brushWithColor:[IFXPDFRgbColor blackColor]];
    
    IFXPDFFont* titleFont = [[IFXPDFFont alloc] init];
    titleFont.fontFace = IFXPDFHelveticaBoldFontFace;
    titleFont.size = 16;
    
    IFXPDFPage* page = [IFXPDFPage emptyPage];
    [pdfDocument.pages addPage:page];
    
    [page.graphics drawText:@"PDF file with document information and viewer preferences"
                   withFont:titleFont brush:blackBrush atX:20 y:50];
    
    
    return pdfDocument;
}

@end
